;******************************************************
;       Copyright 2004 Kawanishi Masashi
;@@@ xK[
;
;	PIC16F84AF4MHzp(1cycle=1us)
;
;	dSW1ƃf[^M[h
;	SW2Ńf[^v[h
;
;	f[^v[h
;	@vJnBf[^L^0.1sƂ10Ԃ܂
;	@XʁAXʁAYʁAYʂ̏4oCg
;	@6000|Cg X 4oCg24,000oCgi192,000bitj
;	@SW1SW2𓯎ɉƌvf
;
;	f[^M[h
;	@9600bps, 8bit, 1stopbit
;	@peB[ȂAt[Ȃ
;	@SWƃeLXgf[^ɗĂ
;	
;	sATC
;	RA0 <- GZT[XM
;	RA1 <- GZT[YM
;	RA2 <-> EEPROM SDA
;	RA3 -> EEPROM SCLK
;	RB1 -> RS232CM
;	RB2 <- RS232CM
;	RB4 <- vbVSW1
;	RB5 <- vbVSW2
;	RB6 -> LED@i1OFF@0ONj
;
;******************************************************

	LIST	P=PIC16F84A
	INCLUDE	"P16F84A.INC"

;******************************
;  ϐWX^`
;******************************

; -------- EEPROM֘A -------------------
eeprom		equ	0CH	; eeprom rbg݁^ǂݍݗpWX^
addrl		equ	0EH	; eeprom AhXiʁj
addrh		equ	0FH	; eeprom AhXiʁj
datai		equ	10H	; eeprom ǂݍݗpf[^
datao		equ	11H	; eeprom ݗpf[^1oCg
datao2		equ	12H	; eeprom ݗpf[^2oCg
datao3		equ	13H	; eeprom ݗpf[^3oCg
datao4		equ	14H	; eeprom ݗpf[^4oCg
txbuf		equ	16H	; eeprom ϐ󂯓np
count		equ	17H	; eeprom rbgJE^

; --------- ԑ҂[vp -------------
counta		equ	19H	; ԑ҂p̃JE^
countb		equ	1AH
countc		equ	1BH
countd		equ	1CH

counte		equ	1DH	; ėpJE^
countf		equ	1EH

; --------- RS232Cp -------------
sendt		equ	1FH	; RS232CʐMEFCgԂ̒p
bitw		equ	20H	; Mrbg̃JEgp
txdata		equ	21H	; Mf[^iWrbg)i[pϐ

; --------- pXJEgp -------------
xplsh		equ	2AH	; XpXJE^
xplsl		equ	2BH	; XpXJE^
yplsh		equ	2CH	; YpXJE^
yplsl		equ	2DH	; YpXJE^
tmcnth		equ	22H	; [`ԒpJE^
tmcntl		equ	23H	; [`ԒpJE^

; --------- 10iϊp ----------------
hexh		equ	31H	; 16i
hexl		equ	32H	; 16i
dech		equ	2EH	; \iES̈
decm		equ	2FH	; \iE\̈
decl		equ	30H	; \iË

; --------- C[`p --------------
stepl		equ	33H	; XebvJE^
steph		equ	34H	; XebvJE^

;*******************************
;@rbg`
;*******************************

di		equ	7	; eeprom͂eepromWX^7rbg
do		equ	6	; eepromo͂eepromWX^6rbg
sdata		equ	2	; SDAڑ|[gRA2
sclk		equ	3	; SCLڑ|[gRA3
ackf		equ	6	; EEPROMxLEDRB6
btime		equ	D'31'	; RS232CʐMxݒpϐ@9600bps @4MHz
				; btime = ((IV[^g(Hz)^]Xs[h(bps)/4)-10)/3
	org	0

;*************************
;@|[gZbgA
;*************************

	bsf	STATUS, RP0	; TRISݒ̂߃oN؂ւ
	movlw	b'00000011'	; PORTAo͐ݒ : RA0,RA1(1)Aق͏o(0)ɐݒ 
	movwf	TRISA
	movlw	b'00110100'	; PORTBo͐ݒ : RB2,RB4,RB5(1)Aق͏o(0)ɐݒ 
	movwf	TRISB
	bcf	STATUS, RP0	; TRISݒ肪ÎŃoNɖ߂

	movlw	b'00000000'
	movwf	PORTA		; PORTA 
	movlw	b'01000010'
	movwf	PORTB		; PORTB iRS232C, LEDj

;*******************************
;@@C[`
;*******************************

		;SWꂽĎASW1iRB4)Ńf[^M[h
		;SW2(RB5)Ńf[^L^Jn
		;̊LEDi400msŁj_

MENU1		movlw	0C8H		; JE^200ɃZbg
		movwf	counte
		bcf	PORTB, 6	; LED_

MENU2		call	WAIT_1M		; 1msԑ҂
		btfss	PORTB,4		; SW11ioffjXLbv
		goto	DATATR		; onf[^M[h

		btfss	PORTB,5		; SW21ioffjXLbv
		goto	LOG		; onf[^v[h
	
		decfsz	counte, f
		goto	MENU2		; 200񃋁[v

		movlw	0C8H		; JE^200ɃZbg
		movwf	counte
		bsf	PORTB, 6	; LED

MENU3		call	WAIT_1M		; 1msԑ҂
		btfss	PORTB,4		; SW11ioffjXLbv
		goto	DATATR		; onf[^M[h

		btfss	PORTB,5		; SW21ioffjXLbv
		goto	LOG		; onf[^v[h
	
		decfsz	counte, f
		goto	MENU3		; 200񃋁[v

		goto	MENU1

;*******************************
;@@f[^v[h
;*******************************

; ***********  *****************
LOG
		movlw	90H		; XebvJE^Zbg:35536(0000H)-6000Xebv=E890H
		movwf	stepl		; 65536(0000H)-6000Xebv=E890H
		movlw	0E8H		; 1ZĂ䂫A0ɂȂL^I
		movwf	steph

		clrf	addrl		; EEPROM݃AhXZbg
		clrf	addrh

; *********** f[^v *****************
LOG0
		call	Gmeas		; xZT[pXv

; *********** f[^L^ *****************

		movf	xplsl, w	; Xf[^Zbg
		movwf	datao
		movf	xplsh, w
		movwf	datao2
		movf	yplsl, w	; Yf[^Zbg
		movwf	datao3
		movf	yplsh, w
		movwf	datao4

		call	EEPWT		; EEPROM

		incf	addrl, f	; ݃AhX+4Z
		incf	addrl, f
		incf	addrl, f
		incfsz	addrl, f
		goto	LOG2
		incf	addrh, f

; *********** JE^ *****************
LOG2
		incfsz	stepl, f	; XebvJE^Z
		goto	LOG3
		incfsz	steph, f
		goto	LOG4
		goto	LOGend		; I[o[t[L^I
LOG3
		nop
		nop

; *********** SẂivfj *****************
LOG4
		btfsc	PORTB, 4	; SW`FbNEEƂON(0)Ȃ~
		goto	LOG5
		btfsc	PORTB, 5
		goto	LOG6

		goto	LOGend		; ƂĂ̂Œ~
LOG5
		nop
		nop

; *********** LED_ *****************
LOG6					; LED(20ms)点
		bcf	PORTB, 6	
		movlw	14H		; 20񃋁[v
		movwf	countc		; 			C[v(LOG0)܂ł31us
					;			Gmeas(50,004)X1, EEPWT(1,241)X1,@v51,276us
LOG7		call	WAIT_1M		; 1053+2+1+2=1058us
		decfsz	countc, f	; ̃[v1058*20-1=21,159us
		goto	LOG7		; 
		bsf	PORTB, 6	; ܂łōv72,436us

; *********** Ԃ킹ă[v *****************

		movlw	1AH		; 26񃋁[v
		movwf	countc		; 			
LOG8		call	WAIT_1M		; 
		decfsz	countc, f	; ̃[v1058*26-1=26,449us
		goto	LOG8		; 
					; ܂łōv99,945us

		movlw	12H		; 17񃋁[v
		movwf	counta		; 
LOG9		decfsz	counta, f	; 2+3*17-1=52
		goto	LOG9		; 
		nop
		goto	LOG0		; ^Cv100,000us

; *********** vIifj *****************
LOGend					; L^IEEE~}[J[(A5A5)݁A
					; @@@@@@@LED_ł̖[v
		call	WAIT_50M	; EEPROMɏ񂾂΂Ȃ̂ŏ҂
		movlw	0A5H
		movwf	datao
		movwf	datao2
		movwf	datao3
		movwf	datao4		; A5A5Zbg

		call	EEPWT		; EEPROM
LOGend2
		bcf	PORTB, 6	; LED_Ŗ[v
		call	WAIT_500M
		bsf	PORTB, 6
		call	WAIT_500M
		goto	LOGend2

;*******************************
;@@f[^M[h
;*******************************

; EEPROMf[^ǂݏoARS232CőMB
; f[^6000|CgɂȂ邩"A5A5H"ɂȂ܂ŌJԂB

DATATR

		movlw	90H		; XebvJE^Zbg:35536(0000H)-6000Xebv=E890H
		movwf	stepl		; 65536(0000H)-6000Xebv=E890H
		movlw	0E8H		; 1ZĂ䂫A0ɂȂL^I
		movwf	steph

		clrf	addrl		; EEPROMǂݏoAhXZbg
		clrf	addrh

DATATR1
		call	EEPRD		; Xʃf[^ǂݏo
		movf	datai, w
		movwf	hexl		; 10iϊpʃWX^֑

		incf	addrl, f	; AhXʂ+1ZiJオ͋NȂj

		call	EEPRD		; Xʃf[^ǂݏo
		movf	datai, w
		movwf	hexh		; 10iϊpʃWX^֑

		; f[^A5A5łȂ`FbN
		movlw	0A5H
		subwf	hexh, w		; hexh - w  w
		btfss	STATUS, Z	; ZtO1i=Zʂ0jXLbv
		goto	DATATR15
		movlw	0A5H
		subwf	hexl, w		; hexh - w  w
		btfss	STATUS, Z	; ZtO1i=Zʂ0jXLbv
		goto	DATATR15

		; f[^A5A5
		goto	DATATR3		; MI

DATATR15
		incf	addrl, f	; AhXʂ+1ZiJオ͋NȂj

		call	DECTR		; 10iϊ[`

		movlw	30H		; ASCIIR[hɕϊi+30Hj
		addwf	dech, w
		movwf	txdata
		call	RSTRANS		; RS232CM	

		movlw	30H
		addwf	decm, w
		movwf	txdata
		call	RSTRANS	

		movlw	30H
		addwf	decl, w
		movwf	txdata
		call	RSTRANS	

		movlw	","		; J}ŋ؂
		movwf	txdata		
		call	RSTRANS

		call	EEPRD		; Yʃf[^ǂݏo
		movf	datai, w
		movwf	hexl		; 10iϊpʃWX^֑

		incf	addrl, f	; AhXʂ+1ZiJオ͋NȂj

		call	EEPRD		; Yʃf[^ǂݏo
		movf	datai, w
		movwf	hexh		; 10iϊpʃWX^֑

		incfsz	addrl, f	; AhXʂ+1Z
		goto	DATATR2		; J肪ȂDATATR2փWv

		incf	addrh, f	; ʌJグ
DATATR2
		call	DECTR		; 10iϊ[`

		movlw	30H		; ASCIIR[hɕϊi+30Hj
		addwf	dech, w
		movwf	txdata
		call	RSTRANS		; RS232CM	

		movlw	30H
		addwf	decm, w
		movwf	txdata
		call	RSTRANS	

		movlw	30H
		addwf	decl, w
		movwf	txdata
		call	RSTRANS	

		movlw	0DH
		movwf	txdata
		call	RSTRANS		
		movlw	0AH		; 0D, 0AŁusv
		movwf	txdata
		call	RSTRANS	

		incfsz	stepl, f	; XebvJE^[Z
		goto	DATATR1		; JグȂ烋[`փWv
		incfsz	steph, f	; JE^[ʂZ
		goto	DATATR1		; JグȂ烋[`փWv

		; MIALED_ł̖[v
DATATR3
		bcf	PORTB, 6
		call	WAIT_500M
		bsf	PORTB, 6
		call	WAIT_500M
		goto	DATATR3

;***************************************************
;	xZT[pXvTu[`
;	  : 50ms (50,004us)
;	 f[^@ : X xplshiʁj,xplsl(ʁj
;	 @@@@ : Y yplshiʁj,yplsl(ʁj
;	  	  : (P10us)
;***************************************************
Gmeas
	clrf	xplsh		; XpXJE^̃NA
	clrf	xplsl
	clrf	yplsh		; YpXJE^̃NA
	clrf	yplsl		; (JEg4us)

; ****** Tu[`ԒpJE^̃Zbg******
;	tmcnthʁAtmcntlʂ10usƂ
;	PJEgAbvBI[o[t[_
;	50msɂȂ悤ɒĂB
;	[`JEg̏
;	=4+4+3+3+9+3+3+9-4=34us3JEg(4us܂)
;	50ms=50,000us/10us=5,000JEg
;	tmcnt̃I[o[t[65536JEg(FF00)Ŕ
;	65536-5000+3 = 60539 = 0EC7BH

	movlw	07BH
	movwf	tmcntl
	movlw	0ECH
	movwf	tmcnth		; (JEg4us)

; ******  GpX X vJn@**********
GXcount1
	btfss	PORTA, 0	; pXlowɂȂ̂҂
	goto	GXcount2	; low玟֐i
	incfsz	tmcntl, f	; JE^ʂɂPZ
	goto	GXcount11	; 0ł͂ȂꍇiI[o[t[j֐i
	incfsz	tmcnth, f	; JE^ʂɂPZ
	goto	GXcount12	; 0ł͂ȂꍇiI[o[t[j֐i
	return			; ZtO1Ȃ̂Ōv~Areturn
GXcount11
	nop			; pnop
	nop
GXcount12
	nop			; pnop
	goto	GXcount1	; [v10us
				; (JEg3us)

GXcount2
	btfsc	PORTA, 0	; pXhighɂȂ̂҂
	goto	GXcount3	; high玟֐i
	incfsz	tmcntl, f	; JE^ʂɂPZ
	goto	GXcount21	; 0ł͂ȂꍇiI[o[t[j֐i
	incfsz	tmcnth, f	; JE^ʂɂPZ
	goto	GXcount22	; 0ł͂ȂꍇiI[o[t[j֐i
	return			; ZtO1Ȃ̂Ōv~Areturn
GXcount21
	nop			; pnop
	nop
GXcount22
	nop			; pnop
	goto	GXcount2	; [v10us
				; (JEg3us)

	; *****pXJEgJn****

GXcount3	
	incfsz	xplsl, f	; JEglZāA0łȂȂiI[o[t[ĂȂȂj
	goto	GXcount4	; Wv
	incfsz	xplsh, f	; ʂ0ɂȂ̂ŏʃJE^Z
	goto	GXcount5	; I[o[t[ĂȂȂWv
	return			; I[o[t[iُlj^[

GXcount4
	nop			; I[o[t[ĂȂꍇ̎ԍ킹
	nop
GXcount5
	nop			; 1[v10usɂȂ悤nop̐Œ߂
	nop
	btfsc	PORTA, 0
	goto	GXcount3	; pXlowɂȂ܂Ń[v

GXcount6
	;*** vApJE^Z ***
	movf	xplsl, w
	addwf	tmcntl, f
	btfsc	STATUS, C
	incfsz	tmcnth, f
	goto	GXcount7
	return			; I[o[t[̂return
GXcount7
	movf	xplsh, w
	addwf	tmcnth, f
	btfsc	STATUS, C
	return			; I[o[t[̂return
				; (JEg9us)

; ******  GpX Y vJn@**********

	; ***** pXオ܂ő҂ ******
GYcount1
	btfss	PORTA, 1	; pXlowɂȂ̂҂
	goto	GYcount2	; low玟֐i
	incfsz	tmcntl, f	; JE^ʂɂPZ
	goto	GYcount11	; 0ł͂ȂꍇiI[o[t[j֐i
	incfsz	tmcnth, f	; JE^ʂɂPZ
	goto	GYcount12	; 0ł͂ȂꍇiI[o[t[j֐i
	return			; ZtO1Ȃ̂Ōv~Areturn
GYcount11
	nop			; pnop
	nop
GYcount12
	nop			; pnop
	goto	GYcount1	; [v10us
				; (JEg3us)

GYcount2
	btfsc	PORTA, 1	; pXhighɂȂ̂҂
	goto	GYcount3	; high玟֐i
	incfsz	tmcntl, f	; JE^ʂɂPZ
	goto	GYcount21	; 0ł͂ȂꍇiI[o[t[j֐i
	incfsz	tmcnth, f	; JE^ʂɂPZ
	goto	GYcount22	; 0ł͂ȂꍇiI[o[t[j֐i
	return			; ZtO1Ȃ̂Ōv~Areturn
GYcount21
	nop			; pnop
	nop
GYcount22
	nop			; pnop
	goto	GYcount2	; [v10us
				; (JEg3us)

	; *****pXJEgJn****

GYcount3	
	incfsz	yplsl, f	; JEglZāA0łȂȂiI[o[t[ĂȂȂj
	goto	GYcount4	; Wv
	incfsz	yplsh, f	; ʂ0ɂȂ̂ŏʃJE^Z
	goto	GYcount5	; I[o[t[ĂȂȂWv
	return			; I[o[t[(ُlj^[

GYcount4
	nop			; I[o[t[ĂȂꍇ̎ԍ킹
	nop
GYcount5
	nop			; 1[v10usɂȂ悤nop̐Œ߂
	nop
	btfsc	PORTA, 1
	goto	GYcount3	; pXlowɂȂ܂Ń[v

GYcount6
	;*** vApJE^Z ***
	movf	yplsl, w
	addwf	tmcntl, f
	btfsc	STATUS, C
	incfsz	tmcnth, f
	goto	GYcount7
	return			; I[o[t[̂return
GYcount7
	movf	yplsh, w
	addwf	tmcnth, f
	btfsc	STATUS, C
	return			; I[o[t[̂return
				; (JEg9us)

; *********** 50mso߂܂ő҂Ă烊^[ ****************
Gtime1
	incfsz	tmcntl, f	; JE^ʂɂPZ
	goto	Gtime2		; 0ł͂ȂꍇiI[o[t[j֐i
	incfsz	tmcnth, f	; JE^ʂɂPZ
	goto	Gtime3		; 0ł͂ȂꍇiI[o[t[j֐i

	return			; ҂ԏIA^[
				; (JEg-4us)
Gtime2
	nop
	nop
Gtime3
	nop
	nop
	nop
	goto	Gtime1

;***************************************************
;	EEPROMf[^ Tu[`
;	(xɂSoCg) 1241us
;	AhX : addrh, addrl
;	f[^@ : datao, datao2, datao3, datao4
;***************************************************

EEPWT	
	call	BSTART		; X^[grbg

	movlw	b'10100000'	; Rg[oCg𑗐M
	movwf	txbuf		
	call	TX		
	movf	addrh,w		; ݃AhXʂ𑗐M
	movwf	txbuf		
	call	TX		
	movf	addrl,w		; ݃AhXʂ𑗐M
	movwf	txbuf		
	call	TX		
	movf	datao,w		; f[^oCg1oCgڑM
	movwf	txbuf	
	call	TX	
	movf	datao2,w	; f[^oCg2oCgڑM
	movwf	txbuf		
	call	TX	
	movf	datao3,w	; f[^oCg3oCgڑM
	movwf	txbuf	
	call	TX	
	movf	datao4,w	; f[^oCg4oCgڑM
	movwf	txbuf		
	call	TX	

	call	BSTOP		;@XgbvrbgAݏ

	return			; 34+19+167X7+19 = 1241us

;********************************************************
;	EEPROMf[^ǂݍ݃Tu[`
;	AhX : addrh, addrl
;	f[^ : datai
;********************************************************

EEPRD	
	call	BSTART		; X^[grbg

	movlw	b'10100000'	; Rg[oCg𑗐Mi݃[hj
	movwf	txbuf		
	call	TX		
	movf	addrh,w		; ǂݍ݃AhXʂ𑗐M
	movwf	txbuf		
	call	TX		
	movf	addrl,w		; ǂݍ݃AhXʂ𑗐M
	movwf	txbuf		
	call	TX		

	call	BSTART		; X^[grbg

	movlw	b'10100001'	; Rg[oCgMiǂݍ݃[hɁj
	movwf	txbuf		
	call	TX		

	call	RX		; oCgǂݍ

	call	BSTOP		; Xgbvrbg

	return

; ********* oCgf[^MTu[`(167us)@**********

TX
	movlw	08H		
	movwf	count		; 1oCg8rbgJԂpJE^

TXLP
	bcf	eeprom,do	; eepromݗprbg0ɂĂ
	btfsc	txbuf, 7	; ݃f[^͖{0H
	bsf	eeprom,do	; @݃f[^1̂ŏݗprbg1ɂ

	btfss	eeprom,do	; ݃f[^rbg͂PH
	goto	bitlow		; 
	bsf	PORTA, sdata	; ݃rbgP̏ꍇFSDAHighɂ
	goto	clkout		; NbNփWv
bitlow
	bcf	PORTA, sdata	; ݃rbgȌꍇFSDALowɂ
	nop			;
clkout
	bsf	PORTA, sclk	; SCLHighɂ
	nop
	nop
	nop
	nop
	bcf	PORTA, sclk	; SCLLowɂB܂łŃrbg݊

	rlf	txbuf, f	; Mf[^oCgVtg
	decfsz	count, f	; 8rbgMIH
	goto	TXLP		; I܂Ń[v([vv18X8-1=143us)

	;** ACKrbgM ***

	bsf	eeprom,di	; eepromǂݍݗprbg1ɂĂ

	bsf	STATUS, RP0
	bsf	TRISA, sdata	; SDA|[g͂ɂ
	bcf	STATUS, RP0

	bsf	PORTA, sclk	; SCLHighɂ
	nop
	nop
	nop
	nop
	nop
	btfss	PORTA, sdata   	; SDA|[g̓͂`FbN
	bcf	eeprom, di	; |[glow̏ꍇAǂݍ݃rbg0ɕύX
	bcf	PORTA, sclk    	; SCLLowɂ
	nop

	bsf	STATUS, RP0
	bcf	TRISA, sdata	; SDA|[go͂ɖ߂
	bcf	STATUS, RP0

	nop
	btfsc	eeprom,di	; ǂݍ݃rbg`FbNĎsĂ
	bcf	PORTB, ackf	; LED_
	return			; [`ŏ鎞ԍv=2+143+22=167us

; ********* oCgf[^MTu[`(197us)@**********

RX
	clrf	datai		; ǂݍݗpWX^NA
	movlw	.8		; set # bits to 8
	movwf	count
	bcf	STATUS,0	; L[rbg0ɂĂB
RXLP
	rlf	datai, F	; ǂݍݗpWX^VtgBŉʂ0ɂȂĂ

	bsf	eeprom,di	; eepromǂݍݗprbg1ɂĂ

	bsf	STATUS, RP0
	bsf	TRISA, sdata	; SDA|[g͂ɂ
	bcf	STATUS, RP0

	bsf	PORTA, sclk	; SCLHighɂ
	nop			
	nop
	nop
	nop
	nop
	btfss	PORTA, sdata   	; SDA|[g̓͂`FbN
	bcf	eeprom, di	; |[glow̏ꍇAǂݍ݃rbg0ɕύX
	bcf	PORTA, sclk	; SCLLowɂ
	nop

	bsf	STATUS, RP0
	bcf	TRISA, sdata	; SDA|[go͂ɖ߂
	bcf	STATUS, RP0

	btfsc	eeprom,di	; ǂݏorbgP
	bsf	datai,0		; ǂݍݗpWX^̍ŉʂ1ɂ
	decfsz	count, f	; 8rbgMIH
	goto	RXLP		; I܂Ń[v ([vv23X8-1=183)

	;** ACKrbgM ***

	bsf	eeprom,do	; ACKo͗prbg1ɂĂ
	bsf	PORTA, sdata	; SDA|[gHigh 
	bsf	PORTA, sclk	; SCLHighɂ
	nop
	nop
	nop
	nop
	bcf	PORTA, sclk	; SCLLowɂ

	return			; [`ŏ鎞ԍv=4+183+10=197us

; ********** X^[grbgTu[`(19us)  *******

BSTART
	bsf	PORTA, sdata	; SDAHighɂĂ
	nop			
	nop
	nop
	bsf	PORTA, sclk	; SCLHighɂĂ
	nop
	nop
	nop
	bcf	PORTA, sdata	; SDALowɂB
				; SCLHigh̊ԂSDALowɂȂ
	nop			; X^[grbgƂĔF
	nop
	nop			
	bcf	PORTA, sclk	; NbNLowɖ߂B
	nop
	nop
	nop
	nop
	return

; ********** XgbvrbgTu[`(19us)  *******

BSTOP
	bcf	PORTA, sdata	; SDALowɂĂ
	nop
	nop
	nop
	bsf	PORTA, sclk	; SCLHighɂ
	nop
	nop    
	nop
	bsf	PORTA, sdata	; SDAHighɂB
				; SCLHigh̊ԂSDAHighɂȂ
	nop			; XgbvrbgƂĔF
	nop
	nop
	bcf	PORTA, sclk	; NbNLowɖ߂B
	nop
	nop
	nop
	nop
	return

;************************************************
;            RS232C M[` 
;              txdata̒l𑗐M  
;************************************************

RSTRANS
		bcf	PORTB, 1	; X^[grbgMJnBM|[gRB1Low

		movlw	btime		; ]ԑ҂pJE^[
		movwf	sendt		; btime͂炩ߓ]xɂ킹Ē`ĂKv

TRANS10		decfsz	sendt, f
		goto	TRANS10		; ]x(ł9600bps)ɂ킹Ďԑ҂

		movlw	08H
		movwf	bitw		; M̒Pʂ8rbg1f[^Bbitw8rbgJEgpϐB
		nop

TRANS0		rrf	txdata, f	; txdataiMf[^j̍ŉʂ̃rbgCiL[rbgjɁA
		nop			; ̑̃rbg͂ꂼ1ʂ̂قiEjփVtg

		btfss	STATUS,C	; Crbg1瑗M|[gRB1highɁA0lowɂ
		bcf	PORTB, 1	; ʃrbg瑗M邱ƂɂȂ
		btfsc	STATUS,C
		bsf	PORTB, 1

		movlw	btime
		movwf	sendt
		
TRANS11		decfsz	sendt, f
		goto	TRANS11		; ]x(ł9600bps)ɂ킹Ďԑ҂

		decfsz	bitw, f		; rbgJE^1炷B
		goto	TRANS0		; ܂WrbgMĂȂ玟̃rbg𑗐M

		nop			; nopŎԒ
		nop
		nop
		nop
		nop
		nop
		bsf	PORTB, 1	; ŌɃXgbvrbg𑗐M
		movlw	btime
		movwf	sendt

TRANS12		decfsz	sendt, f	; stoprbgEFCg
		goto	TRANS12

		return

;******************************************************
;	\iɕϊ郋[` 
;	 16if[^hexh(),hexl()̒l
;	 dech(S̈)Adecm(\̈)Adecl(̈)
;	 ɕϊ	
;******************************************************

DECTR
	clrf	dech
	clrf	decm
	clrf	decl
	
	movf	hexh, w		; ̓f[^0łȂׂ
	btfss	STATUS, Z	; hexh0ꍇAZtO1ɂȂĂ
	goto	DEC1		; hexh(ʃf[^)0łȂ珈Jn
	
	movf	hexl, w
	btfss	STATUS, Z
	goto	DEC1		; hexl(ʃf[^)0łȂ珈Jn

	return			; hexhhexl0̂ŏo̓f[^0̂܂ܕA
DEC1
	call	DECUP		; 10if[^JEgAbv
	decfsz	hexl, f		; ʃf[^0łȂJԂ
	goto	DEC1

				; ʃf[^0ꍇ
	movf	hexh, w		; ʃf[^0łȂׂ
	btfsc	STATUS, Z	; 0ꍇAZ1ɂȂĂ
	goto	DEC2		; ʃf[^0ꍇɂDEC2փWv
	decf	hexh, f		; hexhZ
	goto	DEC1		; ʂ̌ZĊJ
DEC2
	return			; ʂ0ɂȂ̂ŏI

; ******** JEgAbvTu[` ****************

DECUP
	incf	decl, f		;Pځ{P
	movf	decl, w		;PڃI[o[t[`FbN
	sublw	0AH		; W-10
	btfss	STATUS,Z	; W=10̂
	return			; ܂10ɂȂĂȂ̂ŃJEgAbvI

	;***  QڃJEgAbv  ****
	clrf	decl		; 1ڂ0
	incf	decm, f		; 2ځ{P
	movf	decm, w		; 2ڃI[o[t[`FbN
	sublw	0AH		; W-10
	btfss	STATUS,Z	; W=10̂
	return			; ܂10ɂȂĂȂ̂ŃJEgAbvI

	;***  RڃJEgAbv  ****
	clrf	decm		; 2ڂ0
	incf	dech, f		; 3ځ{P
	movf	dech, w		; 3ڃI[o[t[`FbN
	sublw	0AH		; W-10
	btfss	STATUS,Z	; W=10̂
	return			; ܂10ɂȂĂȂ̂ŃJEgAbvI

	;RڂI[o[t[iُ폈j
	clrf	dech		; 3ڂ0ɂ
	return			; A

;*********************************
;  ^C}[Tu[`
;	WAIT_100U :100usec
;	WAIT_1M  :1msec
;	WAIT_50M  :50msec
;	WAIT_500M   :0.5sec
;*********************************

WAIT_100U				;100usec
		movlw	20H		
		movwf	counta		
W_LOOP1		decfsz	counta , f	;2+3*32-1=97
		goto	W_LOOP1
		nop
		return			;97+3=100(usec)

WAIT_1M					;1msec҂[v
		movlw	0AH
		movwf	countb
W_LOOP2		call	WAIT_100U	;2+(100+5)*10-1=1051
		decfsz	countb, f
		goto	W_LOOP2
		return			;1051+2=1053 (=1.053msec)

WAIT_50M				;50msec҂[v
		movlw	32H		;50񃋁[v
		movwf	countc
W_LOOP3		call	WAIT_1M
		decfsz	countc, f
		goto	W_LOOP3
		return

WAIT_500M				;0.5sec҂[v
		movlw	0AH		;10񃋁[v
		movwf	countd
W_LOOP4		call	WAIT_50M		
		decfsz	countd, f
		goto	W_LOOP4
		return	

		end


