;**********************************************************************
;       Copyright 2004 Kawanishi Masashi
;@@@ xv
;
;	PIC16F84AF4MHzp(1cycle=1us)
;
;	dSW1ƃf[^M[h
;	SW2Ńf[^v[h
;
;	f[^v[h
;	@0.1sƂX,ỸpXvi10usP,1G=1msj
;	@ÕpXƂ̍ꂼZoiΒljAZB
;	@̒l100i10bԁjώZǍώZl1/4ɂB
;	@iEVtg2j
;	@10bώZlɕʂ2oCgf[^ɂUi60bj
;	@ώZAEEPROMɏށBȏ̃vZX16(960j
;	@܂͒fi{^21bȏ㉟j܂ŌJԂB
;
;	f[^M[h
;	@9600bps, 8bit, 1stopbit
;	@peB[ȂAt[Ȃ
;	@1Ƃ̃f[^ɃeLXgƂđ
;	
;	sATC
;	RA0 <- GZT[XM
;	RA1 <- GZT[YM
;	RA2 <-> EEPROM SDA
;	RA3 -> EEPROM SCLK
;	RB1 -> RS232CM
;	RB2 <- RS232CM
;	RB4 <- vbVSW1
;	RB5 <- vbVSW2
;	RB6 -> LED@i1OFF@0ONj
;
;**********************************************************************

	LIST	P=PIC16F84A
	INCLUDE	"P16F84A.INC"

;******************************
;  ϐWX^`
;******************************

; -------- EEPROM֘A -------------------
eeprom		equ	0CH	; eeprom rbg݁^ǂݍݗpWX^
addrl		equ	0EH	; eeprom AhXiʁj
addrh		equ	0FH	; eeprom AhXiʁj
datai		equ	10H	; eeprom ǂݍݗpf[^
datao		equ	11H	; eeprom ݗpf[^1oCg
datao2		equ	12H	; eeprom ݗpf[^2oCg
txbuf		equ	16H	; eeprom ϐ󂯓np
count		equ	17H	; eeprom rbgJE^

; --------- ԑ҂[vp -------------
counta		equ	19H	; ԑ҂p̃JE^
countb		equ	1AH
countc		equ	1BH
countd		equ	1CH

counte		equ	1DH	; ėpJE^
countf		equ	1EH

; --------- RS232Cp -------------
sendt		equ	1FH	; RS232CʐMEFCgԂ̒p
bitw		equ	20H	; Mrbg̃JEgp
txdata		equ	21H	; Mf[^iWrbg)i[pϐ

; --------- pXJEgp -------------
xplsh		equ	2AH	; XpXJE^
xplsl		equ	2BH	; XpXJE^
yplsh		equ	2CH	; YpXJE^
yplsl		equ	2DH	; YpXJE^
tmcnth		equ	22H	; [`ԒpJE^
tmcntl		equ	23H	; [`ԒpJE^

; --------- 10iϊp ----------------
hexh		equ	31H	; 16i
hexl		equ	32H	; 16i
dec4		equ	24H	; \iË
dec3		equ	25H	; \iË
dec2		equ	2EH	; \iES̈
dec1		equ	2FH	; \iE\̈
dec0		equ	30H	; \iË

; --------- C[`p --------------
stepl		equ	33H	; XebvJE^ʁi960JE^j
steph		equ	34H	; XebvJE^
mincnt		equ	39H	; 1ԃJE^(ől6j
seccnt		equ	3AH	; 10bԃJE^(ől100)
xplshp		equ	35H	; O^[XpXJE^
xplslp		equ	36H	; O^[XpXJE^
yplshp		equ	37H	; O^[YpXJE^
yplslp		equ	38H	; O^[YpXJE^
int1h		equ	3BH	; 10bԃpXώZ
int1l		equ	3CH	; 10bԃpXώZ
int2h		equ	3DH	; 1ԃpXώZ
int2l		equ	3EH	; 1ԃpXώZ
dxh		equ	3FH	; X
dxl		equ	40H	; X
dyh		equ	41H	; Y
dyl		equ	42H	; Y

;*******************************
;@rbg`
;*******************************

di		equ	7	; eeprom͂eepromWX^7rbg
do		equ	6	; eepromo͂eepromWX^6rbg
sdata		equ	2	; SDAڑ|[gRA2
sclk		equ	3	; SCLڑ|[gRA3
ackf		equ	6	; EEPROMxLEDRB6
btime		equ	D'31'	; RS232CʐMxݒpϐ@9600bps @4MHz
				; btime = ((IV[^g(Hz)^]Xs[h(bps)/4)-10)/3
	org	0

;*************************
;@|[gZbgA
;*************************

	bsf	STATUS, RP0	; TRISݒ̂߃oN؂ւ
	movlw	b'00000011'	; PORTAo͐ݒ : RA0,RA1(1)Aق͏o(0)ɐݒ 
	movwf	TRISA
	movlw	b'00110100'	; PORTBo͐ݒ : RB2,RB4,RB5(1)Aق͏o(0)ɐݒ 
	movwf	TRISB
	bcf	STATUS, RP0	; TRISݒ肪ÎŃoNɖ߂

	movlw	b'00000000'
	movwf	PORTA		; PORTA 
	movlw	b'01000010'
	movwf	PORTB		; PORTB iRS232C, LEDj

;*******************************
;@@C[`
;*******************************

		;SWꂽĎASW1iRB4)Ńf[^M[h
		;SW2(RB5)Ńf[^L^Jn
		;̊LEDi400msŁj_

MENU1		movlw	0C8H		; JE^200ɃZbg
		movwf	counte
		bcf	PORTB, 6	; LED_

MENU2		call	WAIT_1M		; 1msԑ҂
		btfss	PORTB,4		; SW11ioffjXLbv
		goto	DATATR		; onf[^M[h

		btfss	PORTB,5		; SW21ioffjXLbv
		goto	LOG		; onf[^v[h
	
		decfsz	counte, f
		goto	MENU2		; 200񃋁[v

		movlw	0C8H		; JE^200ɃZbg
		movwf	counte
		bsf	PORTB, 6	; LED

MENU3		call	WAIT_1M		; 1msԑ҂
		btfss	PORTB,4		; SW11ioffjXLbv
		goto	DATATR		; onf[^M[h

		btfss	PORTB,5		; SW21ioffjXLbv
		goto	LOG		; onf[^v[h
	
		decfsz	counte, f
		goto	MENU3		; 200񃋁[v

		goto	MENU1

;*******************************
;@@f[^v[h
;*******************************

; ***********  *****************
LOG
		movlw	40H		; XebvJE^ZbgF960XebvvpAbvJE^
		movwf	stepl		; 65536(0000H)-960Xebv=FC40H
		movlw	0FCH		; 1ZĂ䂫A0ɂȂL^I
		movwf	steph

		clrf	addrl		; EEPROM݃AhXZbg
		clrf	addrh

		bsf	PORTB, 6	; LED

; *********** rp_~[f[^v *****************

		call	Gmeas		; xZT[pXv

		movf	xplsl, w	; Xf[^O^[pϐɃZbg
		movwf	xplslp
		movf	xplsh, w
		movwf	xplshp
		movf	yplsl, w	; Yf[^O^[pϐɃZbg
		movwf	yplslp
		movf	yplsh, w
		movwf	yplshp

; *********** 1ԃ[vJn ************************
LOGmin
		movlw	6H
		movwf	mincnt		; 1ԃJE^Zbgi10bPX6j
		clrf	int2h		; pXώZlNA
		clrf	int2l

; *********** 10bԃ[vJn ************************
LOGsec
		movlw	64H		; 100
		movwf	seccnt		; 1ԃJE^Zbgi0.1bPX100j
		clrf	int1h		; pXώZlNA
		clrf	int1l

; *********** f[^vAvZ *****************
LOG_00
		call	Gmeas		; xZT[pXv

		; **** XFOf[^Ƃ̍iΒljZo
		; **** O^[f[^ƌf[^ǂ炪傫H

		movf	xplshp, w
		subwf	xplsh, w	; ʍׂFf[^ - Of[^  w

		btfsc	STATUS, C	; C=0̏ꍇ(ʂ̏ꍇ)XLbv
		goto	LOG_02

		; ʍFOf[^ - f[^  dxh,dxl

		movf	xplsh, w	; ʃoCgZ xplshpiOf[^j- xplshif[^j
		subwf	xplshp, w
		movwf	dxh		; w  dxh

		movf	xplsl, w	; ʃoCgZ xplslpiOf[^j- xplslif[^j
		subwf	xplslp, w
		movwf	dxl		; w  dxl
		btfss	STATUS, C	; C=1(ʂ0jXLbv
		decf	dxh, f		; ʌŽʂ̂ŏʂ1J艺

		nop			; ԍ킹
		nop
		goto	LOG_06		; Y̌vZ

LOG_02		; ʍ0̏ꍇ
		btfss	STATUS, Z	; Z=1iʂ0jXLbv
		goto	LOG_04		; ʂ̂ŃWv

		; ʍ0ł
		clrf	dxh
		clrf	dxl
		movf	xplslp, w	; ʃf[^Z
		subwf	xplsl, w	; f[^ - Of[^  w

		btfss	STATUS, C	; C=1̏ꍇ(ʂ0̏ꍇ)XLbv
		subwf	dxl, w		; ʂ̂ dxl(ł0) - w  w

		movwf	dxl		; w  dxl

		goto	LOG_06		; Y̌vZ

LOG_04		; ʍłFf[^ - Of[^  dxh,dxl

		movf	xplshp, w	; ʃoCgZ xplshif[^j- xplshpiOf[^j
		subwf	xplsh, w
		movwf	dxh		; w  dxh

		movf	xplslp, w	; ʃoCgZ xplslif[^j- xplslpiOf[^j
		subwf	xplsl, w
		movwf	dxl		; w  dxl
		btfss	STATUS, C	; C=1(ʂ0jXLbv
		decf	dxh, f		; ʌŽʂ̂ŏʂ1J艺

LOG_06
		; **** Y FOf[^Ƃ̍iΒljZo
		; **** O^[f[^ƌf[^ǂ炪傫H

		movf	yplshp, w
		subwf	yplsh, w	; ʍׂFf[^ - Of[^  w

		btfsc	STATUS, C	; C=0̏ꍇ(ʂ̏ꍇ)XLbv
		goto	LOG_08

		; ʍFOf[^ - f[^  dyh,dyl

		movf	yplsh, w	; ʃoCgZ yplshpiOf[^j- yplshif[^j
		subwf	yplshp, w
		movwf	dyh		; w  dyh

		movf	yplsl, w	; ʃoCgZ yplslpiOf[^j- yplslif[^j
		subwf	yplslp, w
		movwf	dyl		; w  dyl
		btfss	STATUS, C	; C=1(ʂ0jXLbv
		decf	dyh, f		; ʌŽʂ̂ŏʂ1J艺

		nop			; ԍ킹
		nop
		goto	LOG_12		; f[^Z

LOG_08		; ʍ0̏ꍇ
		btfss	STATUS, Z	; Z=1iʂ0jXLbv
		goto	LOG_10		; ʂ̂ŃWv

		; ʍ0ł
		clrf	dyh
		clrf	dyl
		movf	yplslp, w	; ʃf[^Z
		subwf	yplsl, w	; f[^ - Of[^  w

		btfss	STATUS, C	; C=1̏ꍇ(ʂ0̏ꍇ)XLbv
		subwf	dyl, w		; ʂ̂ dyl(ł0) - w  w

		movwf	dyl		; w  dyl

		goto	LOG_12		; f[^Z

LOG_10		; ʍłFf[^ - Of[^  dyh,dyl

		movf	yplshp, w	; ʃoCgZ yplshif[^j- yplshpiOf[^j
		subwf	yplsh, w
		movwf	dyh		; w  dyh

		movf	yplslp, w	; ʃoCgZ yplslif[^j- yplslpiOf[^j
		subwf	yplsl, w
		movwf	dyl		; w  dyl
		btfss	STATUS, C	; C=1(ʂ0jXLbv
		decf	dyh, f		; ʌŽʂ̂ŏʂ1J艺

; *************** f[^Z ******************************
LOG_12
		movf	dxl, w		; dxl  w
		addwf	int1l, f	; w + int1l  int1l
		btfsc	STATUS, C	; C=0iJグȂjȂ玟XLbv
		incf	int1h, f	; JグAint1h + 1  int1h
		movf	dxh, w		; dxh  w
		addwf	int1h, f	; w + int1h  int1h

		movf	dyl, w		; dyl  w
		addwf	int1l, f	; w + int1l  int1l
		btfsc	STATUS, C	; C=0iJグȂjȂ玟XLbv
		incf	int1h, f	; JグAint1h + 1  int1h
		movf	dyh, w		; dyh  w
		addwf	int1h, f	; w + int1h  int1h

		movf	xplsl, w	; f[^Of[^WX^ɃRs[
		movwf	xplslp
		movf	xplsh, w
		movwf	xplshp
		movf	yplsl, w
		movwf	yplslp
		movf	yplsh, w
		movwf	yplshp

		decfsz	seccnt, f	; 10b[vpJE^ZA0Ȃ玟XLbv
		goto	LOG_14		; 0łȂ̂Ŏԑ҂

		goto	LOG_20		; 0̂10bԃ[v

; ************ ԑ҂̌0.1bԃ[v֖߂ *********************
;   ܂Ń[v(LOG_00)18+16+23+50,004=50,061usB
;   c100,000-50,061=49,939us
LOG_14
		; *********** SẂivfj *****************
		btfsc	PORTB, 4	; SW`FbNEEƂON(0)Ȃ~
		goto	LOG_142
		btfsc	PORTB, 5
		goto	LOG_144
		goto	LOGswcheck	; ƂĂ̂ŒfH
					; XCb``FbN
LOG_142
		nop
		nop
LOG_144
		movlw	2FH		; 47񃋁[v
		movwf	countc
LOG_16		call	WAIT_1M		; 2+1053
		decfsz	countc, f
		goto	LOG_16		; 5+2+(2+1053+1+2)*47-1=49,732

		call	WAIT_100U	; 102
		call	WAIT_100U	; 102
					; ̂9
		nop
		goto	LOG_00		; 49,732+102+102+3=49,939

; *************** 10bԃ[v ***********************
;   ܂Ń[v(LOGsec)4+18+16+23+50,004+1=50,066usB
;   c100,000-50,066=49,934us
LOG_20
		; ώZl1/4ɂ鏈
		bcf	STATUS, C	; C0ɂ
		rrf	int1h, f	; ʃoCgEVtgAŏʂ0
		rrf	int1l, f	; ʃoCgEVtgAŏʂ͑OʃoCg̍ŉʃrbg
		bcf	STATUS, C	; xA1/4
		rrf	int1h, f
		rrf	int1l, f

		; int2h/lɉZ
		movf	int1l, w	; int1l  w
		addwf	int2l, f	; w + int2l  int2l
		btfsc	STATUS, C	; C=0iJグȂjȂ玟XLbv
		incf	int2h, f	; JグAint2h + 1  int2h
		movf	int1h, w	; int1h  w
		addwf	int2h, f	; w + int2h  int2h

		; LEDƌ点
		bcf	PORTB, 6	; LED_
		movlw	14H		; 20񃋁[v
		movwf	countc		; 			
					;			
LOG_21		call	WAIT_1M		; 1053+2+1+2=1058us
		decfsz	countc, f	; ̃[v1058*20-1=21,159us
		goto	LOG_21		; 
		bsf	PORTB, 6	; ܂ł16+21,159=21,175us

		decfsz	mincnt, f	; 1ԃ[vpJE^ZA0Ȃ玟XLbv
		goto	LOG_22		; 0łȂ̂Ŏԑ҂

		goto	LOG_26		; 0̂1ԃ[v

; ************ ԑ҂̌10bԃ[v֖߂ *********************
;   c49,934-21,178=28,756us
LOG_22	
		movlw	1BH		; 27񃋁[v
		movwf	countc
LOG_24		call	WAIT_1M		; 2+1053
		decfsz	countc, f
		goto	LOG_24		; 2+(2+1053+1+2)*27-1=28567

		movlw	03EH		; 03EH=62		
		movwf	counta		
LOG_25		decfsz	counta , f	; 2+3*62-1=187
		goto	LOG_25		

		goto	LOGsec		; 28,567+187+2=28,756

; *************** 1ԃ[v ***********************
;   ܂Ń[v(LOGmin)4+50,066+21,175+4=71,249usB
;   c100,000-71,249=28,751us
LOG_26
		movf	int2l, w	; ώZlʃf[^Zbg
		movwf	datao
		movf	int2h, w	; ώZlʃf[^Zbg
		movwf	datao2

		call	EEPWT		; EEPROM (Tu[`899us)

		incf	addrl, f	; ݃AhX+4Z
		incfsz	addrl, f
		goto	LOG_28
		incf	addrh, f

LOG_28
		incfsz	stepl, f	; XebvJE^Z
		goto	LOG_30
		incfsz	steph, f
		goto	LOG_32		; 1ԃ[vp
		goto	LOGend		; I[o[t[L^I
LOG_30
		nop
		nop

; ************ ԑ҂̌1ԃ[v֖߂ *********************
;   c28,751-(15+899)=27,837us
LOG_32
		movlw	1AH		; 26񃋁[v
		movwf	countc
LOG_34		call	WAIT_1M		; 2+1053
		decfsz	countc, f
		goto	LOG_34		; 2+(2+1053+1+2)*26-1=27,509

		movlw	6CH		; 108		
		movwf	counta		
LOG_35		decfsz	counta , f	; 2+3*108-1=325
		goto	LOG_35		

		nop
		goto	LOGmin		; 27,509+325+3=27,837us

; *********** SW`FbNF~H ***************
LOGswcheck
		call	WAIT_500M
		call	WAIT_500M
		btfsc	PORTB, 4	; SW`FbNEEƂON(0)Ȃ~
		goto	LOG_00		; SWoff̂Ń[v擪ɖ߂vs
		btfsc	PORTB, 5
		goto	LOG_00		; SWoff̂Ń[v擪ɖ߂vs
					; ƂĂ̂Œf
	

; *********** vIifj *****************
LOGend					; L^IEEE~}[J[(A5A5)݁A
					; @@@@@@@LED_ł̖[v
		call	WAIT_50M	; EEPROMɏ񂾂΂Ȃ̂ŏ҂
		movlw	0A5H
		movwf	datao
		movwf	datao2		; A5A5Zbg

		call	EEPWT		; EEPROM
LOGend2
		bcf	PORTB, 6	; LED_Ŗ[v
		call	WAIT_500M
		bsf	PORTB, 6
		call	WAIT_500M
		goto	LOGend2

;*******************************
;@@f[^M[h
;*******************************

; EEPROMf[^ǂݏoARS232CőMB
; f[^6000|CgɂȂ邩"A5A5H"ɂȂ܂ŌJԂB

DATATR
		movlw	40H		; XebvJE^ZbgF960XebvvpAbvJE^
		movwf	stepl		; 65536(0000H)-960Xebv=FC40H
		movlw	0FCH		; 1ZĂ䂫A0ɂȂL^I
		movwf	steph

		clrf	addrl		; EEPROM݃AhXZbg
		clrf	addrh

DATATR1
		call	EEPRD		; Xʃf[^ǂݏo
		movf	datai, w
		movwf	hexl		; 10iϊpʃWX^֑

		incf	addrl, f	; AhXʂ+1ZiJオ͋NȂj

		call	EEPRD		; Xʃf[^ǂݏo
		movf	datai, w
		movwf	hexh		; 10iϊpʃWX^֑

		incfsz	addrl, f	; AhXʂ+1Z
		goto	DATATR2		; J肪ȂDATATR2փWv
		incf	addrh, f	; ʌJグ

DATATR2		; f[^A5A5łȂ`FbN
		movlw	0A5H
		subwf	hexh, w		; hexh - w  w
		btfss	STATUS, Z	; ZtO1i=Zʂ0jXLbv
		goto	DATATR15
		movlw	0A5H
		subwf	hexl, w		; hexh - w  w
		btfss	STATUS, Z	; ZtO1i=Zʂ0jXLbv
		goto	DATATR15

		; f[^A5A5
		goto	DATATR3		; MI
DATATR15
		call	DECTR		; 10iϊ[`

		movlw	30H		; ASCIIR[hɕϊi+30Hj
		addwf	dec4, w
		movwf	txdata
		call	RSTRANS		; RS232CM	

		movlw	30H
		addwf	dec3, w
		movwf	txdata
		call	RSTRANS	

		movlw	30H
		addwf	dec2, w
		movwf	txdata
		call	RSTRANS	

		movlw	30H
		addwf	dec1, w
		movwf	txdata
		call	RSTRANS	

		movlw	30H
		addwf	dec0, w
		movwf	txdata
		call	RSTRANS	

		movlw	0DH
		movwf	txdata
		call	RSTRANS		
		movlw	0AH		; 0D, 0AŁusv
		movwf	txdata
		call	RSTRANS	

		incfsz	stepl, f	; XebvJE^[Z
		goto	DATATR1		; JグȂ烋[`փWv
		incfsz	steph, f	; JE^[ʂZ
		goto	DATATR1		; JグȂ烋[`փWv

		; MIALED_ł̖[v
DATATR3
		bcf	PORTB, 6
		call	WAIT_500M
		bsf	PORTB, 6
		call	WAIT_500M
		goto	DATATR3

;***************************************************
;	xZT[pXvTu[`
;	  : 50ms (50,004us)
;	 f[^@ : X xplshiʁj,xplsl(ʁj
;	 @@@@ : Y yplshiʁj,yplsl(ʁj
;	  	  : (P10us)
;***************************************************
Gmeas
	clrf	xplsh		; XpXJE^̃NA
	clrf	xplsl
	clrf	yplsh		; YpXJE^̃NA
	clrf	yplsl		; (JEg4us)

; ****** Tu[`ԒpJE^̃Zbg******
;	tmcnthʁAtmcntlʂ10usƂ
;	PJEgAbvBI[o[t[_
;	50msɂȂ悤ɒĂB
;	[`JEg̏
;	=4+4+3+3+9+3+3+9-4=34us3JEg(4us܂)
;	50ms=50,000us/10us=5,000JEg
;	tmcnt̃I[o[t[65536JEg(FF00)Ŕ
;	65536-5000+3 = 60539 = 0EC7BH

	movlw	07BH
	movwf	tmcntl
	movlw	0ECH
	movwf	tmcnth		; (JEg4us)

; ******  GpX X vJn@**********
GXcount1
	btfss	PORTA, 0	; pXlowɂȂ̂҂
	goto	GXcount2	; low玟֐i
	incfsz	tmcntl, f	; JE^ʂɂPZ
	goto	GXcount11	; 0ł͂ȂꍇiI[o[t[j֐i
	incfsz	tmcnth, f	; JE^ʂɂPZ
	goto	GXcount12	; 0ł͂ȂꍇiI[o[t[j֐i
	return			; ZtO1Ȃ̂Ōv~Areturn
GXcount11
	nop			; pnop
	nop
GXcount12
	nop			; pnop
	goto	GXcount1	; [v10us
				; (JEg3us)

GXcount2
	btfsc	PORTA, 0	; pXhighɂȂ̂҂
	goto	GXcount3	; high玟֐i
	incfsz	tmcntl, f	; JE^ʂɂPZ
	goto	GXcount21	; 0ł͂ȂꍇiI[o[t[j֐i
	incfsz	tmcnth, f	; JE^ʂɂPZ
	goto	GXcount22	; 0ł͂ȂꍇiI[o[t[j֐i
	return			; ZtO1Ȃ̂Ōv~Areturn
GXcount21
	nop			; pnop
	nop
GXcount22
	nop			; pnop
	goto	GXcount2	; [v10us
				; (JEg3us)

	; *****pXJEgJn****

GXcount3	
	incfsz	xplsl, f	; JEglZāA0łȂȂiI[o[t[ĂȂȂj
	goto	GXcount4	; Wv
	incfsz	xplsh, f	; ʂ0ɂȂ̂ŏʃJE^Z
	goto	GXcount5	; I[o[t[ĂȂȂWv
	return			; I[o[t[iُlj^[

GXcount4
	nop			; I[o[t[ĂȂꍇ̎ԍ킹
	nop
GXcount5
	nop			; 1[v10usɂȂ悤nop̐Œ߂
	nop
	btfsc	PORTA, 0
	goto	GXcount3	; pXlowɂȂ܂Ń[v

GXcount6
	;*** vApJE^Z ***
	movf	xplsl, w
	addwf	tmcntl, f
	btfsc	STATUS, C
	incfsz	tmcnth, f
	goto	GXcount7
	return			; I[o[t[̂return
GXcount7
	movf	xplsh, w
	addwf	tmcnth, f
	btfsc	STATUS, C
	return			; I[o[t[̂return
				; (JEg9us)

; ******  GpX Y vJn@**********

	; ***** pXオ܂ő҂ ******
GYcount1
	btfss	PORTA, 1	; pXlowɂȂ̂҂
	goto	GYcount2	; low玟֐i
	incfsz	tmcntl, f	; JE^ʂɂPZ
	goto	GYcount11	; 0ł͂ȂꍇiI[o[t[j֐i
	incfsz	tmcnth, f	; JE^ʂɂPZ
	goto	GYcount12	; 0ł͂ȂꍇiI[o[t[j֐i
	return			; ZtO1Ȃ̂Ōv~Areturn
GYcount11
	nop			; pnop
	nop
GYcount12
	nop			; pnop
	goto	GYcount1	; [v10us
				; (JEg3us)

GYcount2
	btfsc	PORTA, 1	; pXhighɂȂ̂҂
	goto	GYcount3	; high玟֐i
	incfsz	tmcntl, f	; JE^ʂɂPZ
	goto	GYcount21	; 0ł͂ȂꍇiI[o[t[j֐i
	incfsz	tmcnth, f	; JE^ʂɂPZ
	goto	GYcount22	; 0ł͂ȂꍇiI[o[t[j֐i
	return			; ZtO1Ȃ̂Ōv~Areturn
GYcount21
	nop			; pnop
	nop
GYcount22
	nop			; pnop
	goto	GYcount2	; [v10us
				; (JEg3us)

	; *****pXJEgJn****

GYcount3	
	incfsz	yplsl, f	; JEglZāA0łȂȂiI[o[t[ĂȂȂj
	goto	GYcount4	; Wv
	incfsz	yplsh, f	; ʂ0ɂȂ̂ŏʃJE^Z
	goto	GYcount5	; I[o[t[ĂȂȂWv
	return			; I[o[t[(ُlj^[

GYcount4
	nop			; I[o[t[ĂȂꍇ̎ԍ킹
	nop
GYcount5
	nop			; 1[v10usɂȂ悤nop̐Œ߂
	nop
	btfsc	PORTA, 1
	goto	GYcount3	; pXlowɂȂ܂Ń[v

GYcount6
	;*** vApJE^Z ***
	movf	yplsl, w
	addwf	tmcntl, f
	btfsc	STATUS, C
	incfsz	tmcnth, f
	goto	GYcount7
	return			; I[o[t[̂return
GYcount7
	movf	yplsh, w
	addwf	tmcnth, f
	btfsc	STATUS, C
	return			; I[o[t[̂return
				; (JEg9us)

; *********** 50mso߂܂ő҂Ă烊^[ ****************
Gtime1
	incfsz	tmcntl, f	; JE^ʂɂPZ
	goto	Gtime2		; 0ł͂ȂꍇiI[o[t[j֐i
	incfsz	tmcnth, f	; JE^ʂɂPZ
	goto	Gtime3		; 0ł͂ȂꍇiI[o[t[j֐i

	return			; ҂ԏIA^[
				; (JEg-4us)
Gtime2
	nop
	nop
Gtime3
	nop
	nop
	nop
	goto	Gtime1

;***************************************************
;	EEPROMf[^ Tu[`
;	(x2oCg) 899us
;	AhX : addrh, addrl
;	f[^@ : datao, datao2
;***************************************************

EEPWT	
	call	BSTART		; X^[grbg

	movlw	b'10100000'	; Rg[oCg𑗐M
	movwf	txbuf		
	call	TX		
	movf	addrh,w		; ݃AhXʂ𑗐M
	movwf	txbuf		
	call	TX		
	movf	addrl,w		; ݃AhXʂ𑗐M
	movwf	txbuf		
	call	TX		
	movf	datao,w		; f[^oCg1oCgڑM
	movwf	txbuf	
	call	TX	
	movf	datao2,w	; f[^oCg2oCgڑM
	movwf	txbuf		
	call	TX	

	call	BSTOP		;@XgbvrbgAݏ

	return			; 26+21+167X5+17 = 899us

;********************************************************
;	EEPROMf[^ǂݍ݃Tu[`
;	AhX : addrh, addrl
;	f[^ : datai
;********************************************************

EEPRD	
	call	BSTART		; X^[grbg

	movlw	b'10100000'	; Rg[oCg𑗐Mi݃[hj
	movwf	txbuf		
	call	TX		
	movf	addrh,w		; ǂݍ݃AhXʂ𑗐M
	movwf	txbuf		
	call	TX		
	movf	addrl,w		; ǂݍ݃AhXʂ𑗐M
	movwf	txbuf		
	call	TX		

	call	BSTART		; X^[grbg

	movlw	b'10100001'	; Rg[oCgMiǂݍ݃[hɁj
	movwf	txbuf		
	call	TX		

	call	RX		; oCgǂݍ

	call	BSTOP		; Xgbvrbg

	return

; ********* oCgf[^MTu[`(167us)@**********

TX
	movlw	08H		
	movwf	count		; 1oCg8rbgJԂpJE^

TXLP
	bcf	eeprom,do	; eepromݗprbg0ɂĂ
	btfsc	txbuf, 7	; ݃f[^͖{0H
	bsf	eeprom,do	; @݃f[^1̂ŏݗprbg1ɂ

	btfss	eeprom,do	; ݃f[^rbg͂PH
	goto	bitlow		; 
	bsf	PORTA, sdata	; ݃rbgP̏ꍇFSDAHighɂ
	goto	clkout		; NbNփWv
bitlow
	bcf	PORTA, sdata	; ݃rbgȌꍇFSDALowɂ
	nop			;
clkout
	bsf	PORTA, sclk	; SCLHighɂ
	nop
	nop
	nop
	nop
	bcf	PORTA, sclk	; SCLLowɂB܂łŃrbg݊

	rlf	txbuf, f	; Mf[^oCgVtg
	decfsz	count, f	; 8rbgMIH
	goto	TXLP		; I܂Ń[v([vv18X8-1=143us)

	;** ACKrbgM ***

	bsf	eeprom,di	; eepromǂݍݗprbg1ɂĂ

	bsf	STATUS, RP0
	bsf	TRISA, sdata	; SDA|[g͂ɂ
	bcf	STATUS, RP0

	bsf	PORTA, sclk	; SCLHighɂ
	nop
	nop
	nop
	nop
	nop
	btfss	PORTA, sdata   	; SDA|[g̓͂`FbN
	bcf	eeprom, di	; |[glow̏ꍇAǂݍ݃rbg0ɕύX
	bcf	PORTA, sclk    	; SCLLowɂ
	nop

	bsf	STATUS, RP0
	bcf	TRISA, sdata	; SDA|[go͂ɖ߂
	bcf	STATUS, RP0

	nop
	btfsc	eeprom,di	; ǂݍ݃rbg`FbNĎsĂ
	bcf	PORTB, ackf	; LED_
	return			; [`ŏ鎞ԍv=2+143+22=167us

; ********* oCgf[^MTu[`(197us)@**********

RX
	clrf	datai		; ǂݍݗpWX^NA
	movlw	.8		; set # bits to 8
	movwf	count
	bcf	STATUS,0	; L[rbg0ɂĂB
RXLP
	rlf	datai, F	; ǂݍݗpWX^VtgBŉʂ0ɂȂĂ

	bsf	eeprom,di	; eepromǂݍݗprbg1ɂĂ

	bsf	STATUS, RP0
	bsf	TRISA, sdata	; SDA|[g͂ɂ
	bcf	STATUS, RP0

	bsf	PORTA, sclk	; SCLHighɂ
	nop			
	nop
	nop
	nop
	nop
	btfss	PORTA, sdata   	; SDA|[g̓͂`FbN
	bcf	eeprom, di	; |[glow̏ꍇAǂݍ݃rbg0ɕύX
	bcf	PORTA, sclk	; SCLLowɂ
	nop

	bsf	STATUS, RP0
	bcf	TRISA, sdata	; SDA|[go͂ɖ߂
	bcf	STATUS, RP0

	btfsc	eeprom,di	; ǂݏorbgP
	bsf	datai,0		; ǂݍݗpWX^̍ŉʂ1ɂ
	decfsz	count, f	; 8rbgMIH
	goto	RXLP		; I܂Ń[v ([vv23X8-1=183)

	;** ACKrbgM ***

	bsf	eeprom,do	; ACKo͗prbg1ɂĂ
	bsf	PORTA, sdata	; SDA|[gHigh 
	bsf	PORTA, sclk	; SCLHighɂ
	nop
	nop
	nop
	nop
	bcf	PORTA, sclk	; SCLLowɂ

	return			; [`ŏ鎞ԍv=4+183+10=197us

; ********** X^[grbgTu[`(21us)  *******

BSTART
	bsf	PORTA, sdata	; SDAHighɂĂ
	nop
	bcf	PORTA, sclk	; SCLLowɂĂ
	nop
	bsf	PORTA, sclk	; SCLHighɂāA
	nop			; ԑ҂
	nop
	nop
	nop
	nop
	bcf	PORTA, sdata	; SDALowɂB
				; SCLHigh̊ԂSDALowɂȂ
	nop			; X^[grbgƂĔF
	nop
	nop			; ԑ҂
	nop
	nop
	bcf	PORTA, sclk	; NbNLowɖ߂B
	nop
	nop
	return

; ********** XgbvrbgTu[`(17us)  *******

BSTOP
	bcf	PORTA, sdata	; SDALowɂĂ
	nop
	nop
	nop
	bsf	PORTA, sclk	; SCLHighɂ
	nop
	nop    
	nop
	bsf	PORTA, sdata	; SDAHighɂB
				; SCLHigh̊ԂSDAHighɂȂ
	nop			; XgbvrbgƂĔF
	nop
	bcf	PORTA, sclk	; NbNLowɖ߂
	nop
	nop
	nop
	return

;************************************************
;            RS232C M[` 
;              txdata̒l𑗐M  
;************************************************

RSTRANS
		bcf	PORTB, 1	; X^[grbgMJnBM|[gRB1Low

		movlw	btime		; ]ԑ҂pJE^[
		movwf	sendt		; btime͂炩ߓ]xɂ킹Ē`ĂKv

TRANS10		decfsz	sendt, f
		goto	TRANS10		; ]x(ł9600bps)ɂ킹Ďԑ҂

		movlw	08H
		movwf	bitw		; M̒Pʂ8rbg1f[^Bbitw8rbgJEgpϐB
		nop

TRANS0		rrf	txdata, f	; txdataiMf[^j̍ŉʂ̃rbgCiL[rbgjɁA
		nop			; ̑̃rbg͂ꂼ1ʂ̂قiEjփVtg

		btfss	STATUS,C	; Crbg1瑗M|[gRB1highɁA0lowɂ
		bcf	PORTB, 1	; ʃrbg瑗M邱ƂɂȂ
		btfsc	STATUS,C
		bsf	PORTB, 1

		movlw	btime
		movwf	sendt
		
TRANS11		decfsz	sendt, f
		goto	TRANS11		; ]x(ł9600bps)ɂ킹Ďԑ҂

		decfsz	bitw, f		; rbgJE^1炷B
		goto	TRANS0		; ܂WrbgMĂȂ玟̃rbg𑗐M

		nop			; nopŎԒ
		nop
		nop
		nop
		nop
		nop
		bsf	PORTB, 1	; ŌɃXgbvrbg𑗐M
		movlw	btime
		movwf	sendt

TRANS12		decfsz	sendt, f	; stoprbgEFCg
		goto	TRANS12

		return

;******************************************************
;	\iɕϊ郋[` 
;	 16if[^hexh(),hexl()̒l
;	 dec4(̈)`dec0(̈)
;	 ɕϊ	
;******************************************************

DECTR
	clrf	dec4
	clrf	dec3
	clrf	dec2
	clrf	dec1
	clrf	dec0
	
	movf	hexh, w		; ̓f[^0łȂׂ
	btfss	STATUS, Z	; hexh0ꍇAZtO1ɂȂĂ
	goto	DEC1		; hexh(ʃf[^)0łȂ珈Jn
	
	movf	hexl, w
	btfss	STATUS, Z
	goto	DEC1		; hexl(ʃf[^)0łȂ珈Jn

	return			; hexhhexl0̂ŏo̓f[^0̂܂ܕA

; ************* 10,000(2710H)Z *****************
DEC1
	movlw	27H		; ܂ʌZ
	subwf	hexh, w		; hexh - w(27H)  w
	btfss	STATUS, C	; C=1(ʂ0or)̏ꍇXLbv
	goto	DEC30		; C=0(ʂ)̏ꍇ̐̈ʂ

	btfsc	STATUS, Z	; Z=0(ʂjꍇXLbv
	goto	DEC20		; Z=1iʂ0jꍇʃoCg
DEC15
	; ʂ̌ʂ
	movlw	27H
	subwf	hexh, f		; hexh - w(27H)  hexh
	movlw	10H
	subwf	hexl, f		; hexl - w(10H)  hexl
	btfss	STATUS, C	; C=1(ʂ0or)̏ꍇXLbv
	decf	hexh, f		; ʃoCĝŌJ艺
	incf	dec4, f		; 10i@̈ʃJEgAbv
	goto	DEC1		; 10,000ZJԂ
DEC20
	; ʂ̌ʂ0
	movlw	10H		; ʂZĂ݂
	subwf	hexl, w		; hexl - w(10H)  w
	btfss	STATUS, C	; C=1(ʂ0or)̏ꍇXLbv
	goto	DEC30		; C=0(ʂj̏ꍇA̐̈ʂ
	goto	DEC15		; Z

; ************* 1,000(3E8H)Z *****************
DEC30
	movlw	3H		; ܂ʌZ
	subwf	hexh, w		; hexh - w(3H)  w
	btfss	STATUS, C	; C=1(ʂ0or)̏ꍇXLbv
	goto	DEC50		; C=0(ʂ)̏ꍇ̕S̈ʂ

	btfsc	STATUS, Z	; Z=0(ʂjꍇXLbv
	goto	DEC40		; Z=1iʂ0jꍇʃoCg
DEC35
	; ʂ̌ʂ
	movlw	3H
	subwf	hexh, f		; hexh - w(3H)  hexh
	movlw	0E8H
	subwf	hexl, f		; hexl - w(E8H)  hexl
	btfss	STATUS, C	; C=1(ʂ0or)̏ꍇXLbv
	decf	hexh, f		; ʃoCĝŌJ艺
	incf	dec3, f		; 10i@̈ʃJEgAbv
	goto	DEC30		; 1,000ZJԂ
DEC40
	; ʂ̌ʂ0
	movlw	0E8H		; ʂZĂ݂
	subwf	hexl, w		; hexl - w(E8H)  w
	btfss	STATUS, C	; C=1(ʂ0or)̏ꍇXLbv
	goto	DEC50		; C=0(ʂj̏ꍇA̕S̈ʂ
	goto	DEC35		; Z

; ************* 100(64H)Z *****************
DEC50
	movlw	64H		; ʌZ
	subwf	hexl, w		; hexl - w(64H)  w
	btfss	STATUS, C	; C=1(ʂ0or)̏ꍇXLbv
	goto	DEC60		; C=0(ʂ)̏ꍇ̏ʃ`FbN

	; ʌZʂ܂0
	movlw	64H
	subwf	hexl, f		; hexl - w(64H)  hexl
	incf	dec2, f		; 10i@AS̈ʃJEgAbv
	goto	DEC50		; 100ZJԂ
DEC60
	; ʂ̌ʂ
	movf	hexh, w		; ʂ0H
	btfsc	STATUS, Z	; Z=0(ʂ0łȂ)ꍇXLbv
	goto	DEC70		; ʂ0̂ŌZɎ̏\̈ʂ
	decf	hexh, f		; ʂJ艺
	movlw	64H
	subwf	hexl, f		; hexl - w(64H)  hexl
	incf	dec2, f		; 10i@AS̈ʃJEgAbv
	goto	DEC50		; 100ZJԂ	

; ************* 10(0AH)Z *****************
;   ɂ܂łɏhexh͕K0ɂȂĂ
DEC70
	movlw	0AH		; ʌZ
	subwf	hexl, w		; hexl - w(0AH)  w
	btfss	STATUS, C	; C=1(ʂ0or)̏ꍇXLbv
	goto	DEC80		; C=0(ʂ)̏ꍇ̈ʂ

	; ʌZʂ܂0
	movlw	0AH
	subwf	hexl, f		; hexl - w(0AH)  hexl
	incf	dec1, f		; 10i@A\̈ʃJEgAbv
	goto	DEC70		; 10ZJԂ

; ************* 1Z ***********************
DEC80
	movf	hexl, w
	btfsc	STATUS, Z	; Z=0(hexl0łȂjȂ玟XLbv	
	return			; hexl=0Ȃ̂ŃTu[`蕜A
	decf	hexl, f		; 1Z
	incf	dec0, f		; 10i@ÄʃJEgAbv
	goto	DEC80		; 1ZJԂ

;*********************************
;  ^C}[Tu[`
;	WAIT_100U :100usec
;	WAIT_1M  :1msec
;	WAIT_50M  :50msec
;	WAIT_500M   :0.5sec
;*********************************

WAIT_100U				;100usec
		movlw	20H		
		movwf	counta		
W_LOOP1		decfsz	counta , f	;2+3*32-1=97
		goto	W_LOOP1
		nop
		return			;97+3=100(usec)

WAIT_1M					;1msec҂[v
		movlw	0AH
		movwf	countb
W_LOOP2		call	WAIT_100U	;2+(100+5)*10-1=1051
		decfsz	countb, f
		goto	W_LOOP2
		return			;1051+2=1053 (=1.053msec)

WAIT_50M				;50msec҂[v
		movlw	32H		;50񃋁[v
		movwf	countc
W_LOOP3		call	WAIT_1M
		decfsz	countc, f
		goto	W_LOOP3
		return

WAIT_500M				;0.5sec҂[v
		movlw	0AH		;10񃋁[v
		movwf	countd
W_LOOP4		call	WAIT_50M		
		decfsz	countd, f
		goto	W_LOOP4
		return	

		end


