;******************************************************
;       Copyright 2004 Kawanishi Masashi
;@@@ EEPROMeXgvO
;
;	PIC16F84AF4MHzp(1cycle=1us)
;
; 	EEPROM0Ԓn1, 1Ԓn2EEEEE9Ԓn10
;	ށB0Ԓn珇ɐǂݏoẢ
;	LED_łB
;	
;	sATC
;	RA0 <- GZT[XM
;	RA1 <- GZT[YM
;	RA2 <-> EEPROM SDA
;	RA3 -> EEPROM SCLK
;	RB1 -> RS232CM
;	RB2 <- RS232CM
;	RB4 <- vbVSW
;	RB5 <- vbVSW
;	RB6 -> LED@i1OFF@0ONj
;
;
;******************************************************

	LIST	P=PIC16F84A
	INCLUDE	"P16F84A.INC"

;******************************
;  ϐWX^`
;******************************

; -------- EEPROM֘A -------------------
eeprom		equ	0CH	; eeprom rbg݁^ǂݍݗpWX^
addrl		equ	0EH	; eeprom AhXiʁj
addrh		equ	0FH	; eeprom AhXiʁj
datai		equ	10H	; eeprom ǂݍݗpf[^
datao		equ	11H	; eeprom ݗpf[^1oCg
datao2		equ	12H	; eeprom ݗpf[^2oCg
txbuf		equ	16H	; eeprom ϐ󂯓np
count		equ	17H	; eeprom rbgJE^[

; --------- ԑ҂[vp -------------
counta		equ	19H	; ԑ҂p̃JE^
countb		equ	1AH
countc		equ	1BH
countd		equ	1CH

; ---------- ̑ ------------------
counte		equ	1DH	; ėpJE^

;*******************************
;@rbg`
;*******************************

di		equ	7	;eeprom͂eepromWX^7rbg
do		equ	6	;eepromo͂eepromWX^6rbg
sdata		equ	2	;SDAڑ|[gRA2
sclk		equ	3	;SCLڑ|[gRA3
ackf		equ	6	;EEPROMxLEDRB6

	org	0

;**************************
;@|[gZbgA
;**************************

	bsf	STATUS, RP0	;TRISݒ̂߃oN؂ւ
	movlw	b'00000011'	;PORTAo͐ݒ : RA0,RA1(1)Aق͏o(0)ɐݒ 
	movwf	TRISA
	movlw	b'00110100'	;PORTBo͐ݒ : RB2,RB4,RB5(1)Aق͏o(0)ɐݒ 
	movwf	TRISB
	bcf	STATUS, RP0	;TRISݒ肪ÎŃoNɖ߂

	movlw	b'00000000'
	movwf	PORTA		; PORTA 
	movlw	b'01000010'
	movwf	PORTB		; PORTB iRS232C, LEDj

;*******************************
;@@C[`
;*******************************

	; EEPROM

	clrf	addrh		; EEPROM݃AhX0
	clrf	addrl		; addrh͏ʌAaddrl͉ʌ
	clrf	datao		; ݂鐔l
	clrf	datao2		; Tu[`x2oCgލ\
				; ̂߁Adatao2pӂĂ邪Xebv
				; ŏ㏑B
	movlw	0AH
	movwf	counte		; 10񃋁[v邽߂̃JE^

MAIN
	incf	datao, f	; ݃f[^ɂPZ
	
	call	EEPWT		; EEPROM݃[`
				; addrl, addlh̃AhXdatao̒l

	call	WAIT_50M	; ݌̏҂

	incf	addrl, f	; ݃AhXPӂ₷

	decfsz	counte, f	; JE^ZA0ɂȂ烋[v𔲂
	goto	MAIN

	;݊AǂݏoLED_

	clrf	addrl		; AhXZbg

	movlw	0AH
	movwf	counte		; 10񃋁[v邽߂̃JE^

MAIN2
	call	EEPRD		; EEPROMf[^ǂݏo[`
				; addrl, addrh̃AhXf[^ǂݏo
				; dataiɓċAĂ

MAIN3
	bcf	PORTB, 6	; LED_
	call	WAIT_500M
	bsf	PORTB, 6	; LED
	call	WAIT_500M

	decfsz	datai, f	; ǂݏol(datai)̉񐔃[vA_łJԂ
	goto	MAIN3

	call	WAIT_500M		; K񐔓_ŌA1s̃C^[o
	call	WAIT_500M

	incf	addrl, f

	decfsz	counte, f
	goto	MAIN2


MAIN4
	bcf	PORTB, 6	; LED_
	call	WAIT_50M
	bsf	PORTB, 6	; LED
	call	WAIT_50M

	goto	MAIN4	

	


;***************************************************
;	EEPROMf[^ Tu[`
;	@@(xɂQoCg)
;	AhX : addrh, addrl
;	f[^@ : datao, datao2
;***************************************************

EEPWT	
	call	BSTART		; X^[grbg

	movlw	b'10100000'	; Rg[oCg𑗐M
	movwf	txbuf		
	call	TX		
	movf	addrh,w		; ݃AhXʂ𑗐M
	movwf	txbuf		
	call	TX		
	movf	addrl,w		; ݃AhXʂ𑗐M
	movwf	txbuf		
	call	TX		
	movf	datao,w		; f[^oCg1oCgڑM
	movwf	txbuf	
	call	TX	
	movf	datao2,w	; f[^oCg2oCgڑM
	movwf	txbuf		
	call	TX		

	call	BSTOP		;@XgbvrbgAݏ

	return


;********************************************************
;	EEPROMf[^ǂݍ݃Tu[`
;	AhX : addrh, addrl
;	f[^ : datai
;********************************************************

EEPRD	
	call	BSTART		; X^[grbg

	movlw	b'10100000'	; Rg[oCg𑗐Mi݃[hj
	movwf	txbuf		
	call	TX		
	movf	addrh,w		; ǂݍ݃AhXʂ𑗐M
	movwf	txbuf		
	call	TX		
	movf	addrl,w		; ǂݍ݃AhXʂ𑗐M
	movwf	txbuf		
	call	TX		

	call	BSTART		; X^[grbg

	movlw	b'10100001'	; Rg[oCgMiǂݍ݃[hɁj
	movwf	txbuf		
	call	TX		

	call	RX		; oCgǂݍ

	call	BSTOP		; Xgbvrbg

	return

; ********* oCgf[^MTu[`@**********

TX
	movlw	08H		
	movwf	count		; 1oCg8rbgJԂpJE^

TXLP
	bcf	eeprom,do	; eepromݗprbg0ɂĂ
	btfsc	txbuf, 7	; ݃f[^͖{0H
	bsf	eeprom,do	; @݃f[^1̂ŏݗprbg1ɂ

	btfss	eeprom,do	; ݃f[^rbg͂PH
	goto	bitlow		; 
	bsf	PORTA, sdata	; ݃rbgP̏ꍇFSDAHighɂ
	goto	clkout		; NbNփWv

bitlow	bcf	PORTA, sdata	; ݃rbgȌꍇFSDALowɂ
	nop			;
clkout	bsf	PORTA, sclk	; SCLHighɂ
	nop
	nop
	nop
	nop
	bcf	PORTA, sclk	; SCLLowɂB܂łŃrbg݊

	rlf	txbuf, f	; Mf[^oCgVtg
	decfsz	count, f	; 8rbgMIH
	goto	TXLP		; I܂Ń[v

	;** ACKrbgM ***

	bsf	eeprom,di	; eepromǂݍݗprbg1ɂĂ

	bsf	STATUS, RP0
	bsf	TRISA, sdata	; SDA|[g͂ɂ
	bcf	STATUS, RP0

	bsf	PORTA, sclk	; SCLHighɂ
	nop
	nop
	nop
	nop
	nop
	btfss	PORTA, sdata   	; SDA|[g̓͂`FbN
	bcf	eeprom, di	; |[glow̏ꍇAǂݍ݃rbg0ɕύX
	bcf	PORTA, sclk    	; SCLLowɂ
	nop

	bsf	STATUS, RP0
	bcf	TRISA, sdata	; SDA|[go͂ɖ߂
	bcf	STATUS, RP0

	nop
	btfsc	eeprom,di	; ǂݍ݃rbg`FbNĎsĂ
	bcf	PORTB, ackf	; LED_
	return


; ********* oCgf[^MTu[`@**********

RX
	clrf	datai		; ǂݍݗpWX^NA
	movlw	.8		; set # bits to 8
	movwf	count
	bcf	STATUS,0	; L[rbg0ɂĂB
RXLP	rlf	datai, f	; ǂݍݗpWX^VtgBŉʂ0ɂȂĂB

	bsf	eeprom,di	; eepromǂݍݗprbg1ɂĂ

	bsf	STATUS, RP0
	bsf	TRISA, sdata	; SDA|[g͂ɂ
	bcf	STATUS, RP0

	bsf	PORTA, sclk	; SCLHighɂ
	nop			
	nop
	nop
	nop
	nop
	btfss	PORTA, sdata   	; SDA|[g̓͂`FbN
	bcf	eeprom, di	; |[glow̏ꍇAǂݍ݃rbg0ɕύX
	bcf	PORTA, sclk	; SCLLowɂ
	nop

	bsf	STATUS, RP0
	bcf	TRISA, sdata	; SDA|[go͂ɖ߂
	bcf	STATUS, RP0

	btfsc	eeprom,di	; ǂݏorbgP
	bsf	datai,0		; ǂݍݗpWX^̍ŉʂ1ɂ
	decfsz	count, f	; 8rbgMIH
	goto	RXLP		; I܂Ń[v

	;** ACKrbgM ***

	bsf	eeprom,do	; ACKo͗prbg1ɂĂ
	bsf	PORTA, sdata	; SDA|[gHigh 
	bsf	PORTA, sclk	; SCLHighɂ
	nop
	nop
	nop
	nop
	bcf	PORTA, sclk	; SCLLowɂ

	return

;****** X^[grbgTu[`  *******

BSTART
	bsf	PORTA, sdata	; SDAHighɂĂ
	nop			
	nop
	nop
	bsf	PORTA, sclk	; SCLHighɂĂ
	nop
	nop
	nop
	bcf	PORTA, sdata	; SDALowɂB
				; SCLHigh̊ԂSDALowɂȂ
	nop			; X^[grbgƂĔF
	nop
	nop			
	bcf	PORTA, sclk	; NbNLowɖ߂B
	nop
	nop
	nop
	nop
	return


;****** XgbvrbgTu[` *******

BSTOP
	bcf	PORTA, sdata	; SDALowɂĂ
	nop
	nop
	nop
	bsf	PORTA, sclk	; SCLHighɂ
	nop
	nop    
	nop
	bsf	PORTA, sdata	; SDAHighɂB
				; SCLHigh̊ԂSDAHighɂȂ
	nop			; XgbvrbgƂĔF
	nop
	nop
	bcf	PORTA, sclk	; NbNLowɖ߂B
	nop
	nop
	nop
	nop
	return

;*********************************
;  ^C}[Tu[`
;	WAIT_100U :100usec
;	WAIT_1M  :1msec
;	WAIT_50M  :50msec
;	WAIT_500M   :0.5sec
;*********************************

WAIT_100U				;100usec
		movlw	20H		
		movwf	counta		
W_LOOP1		decfsz	counta , f	;2+3*32-1=97
		goto	W_LOOP1
		nop
		return			;97+3=100(usec)

WAIT_1M					;1msec҂[v
		movlw	0AH
		movwf	countb
W_LOOP2		call	WAIT_100U	;2+(100+5)*10-1=1051
		decfsz	countb, f
		goto	W_LOOP2
		return			;1051+2=1053 (=1.053msec)

WAIT_50M				;50msec҂[v
		movlw	32H		;50񃋁[v
		movwf	countc
W_LOOP3		call	WAIT_1M
		decfsz	countc, f
		goto	W_LOOP3
		return

WAIT_500M					;0.5sec҂[v
		movlw	0AH		;10񃋁[v
		movwf	countd
W_LOOP4		call	WAIT_50M		
		decfsz	countd, f
		goto	W_LOOP4
		return	

		end







