;******************************************************
;        Copyright 2004 Kawanishi Masashi
;@@@@RS232CeXgvO
;
;	PIC16F84AF4MHzp(1cycle=1us)
;
;	@9600bps, 8bit, 1stopbit
;	@peB[ȂAt[Ȃ
;
;	vbVXCb`SW1ƕ
;	"Hello!"𑗐MALED_ŁAJԂB
;	
;	sATC
;	RA0 <- GZT[XM
;	RA1 <- GZT[YM
;	RA2 <-> EEPROM SDA
;	RA3 -> EEPROM SCLK
;	RB1 -> RS232CM
;	RB2 <- RS232CM
;	RB4 <- vbVSW1
;	RB5 <- vbVSW2
;	RB6 -> LED@i1OFF@0ONj
;
;******************************************************

	LIST	P=PIC16F84A
	INCLUDE	"P16F84A.INC"

;******************************
;  ϐWX^`
;******************************

counta		equ	19H		; ԑ҂p̃JE^
countb		equ	1AH
countc		equ	1BH
countd		equ	1CH

sendt		equ	1FH		; RS232CʐMEFCgԂ̒p
bitw		equ	20H		; Mrbg̃JEgp
txdata		equ	21H		; Mf[^iWrbg)i[pϐ

;*******************************
;@rbg`
;*******************************

btime		equ	D'31'	; RS232CʐMxݒpϐ@9600bps @4MHz
				; btime = ((IV[^g(Hz)^]Xs[h(bps)/4)-10)/3

	org	0

;********************
;@|[gZbgA
;********************

	bsf	STATUS, RP0	;TRISݒ̂߃oN؂ւ
	movlw	b'00000011'	;PORTAo͐ݒ : RA0,RA1(1)Aق͏o(0)ɐݒ 
	movwf	TRISA
	movlw	b'00110100'	;PORTBo͐ݒ : RB2,RB4,RB5(1)Aق͏o(0)ɐݒ 
	movwf	TRISB
	bcf	STATUS, RP0	;TRISݒ肪ÎŃoNɖ߂

	movlw	b'00000000'
	movwf	PORTA		; PORTA 
	movlw	b'01000010'
	movwf	PORTB		; PORTB iRS232C, LEDj


;*******************************
;@@C[`
;*******************************

MAIN1
	btfsc	PORTB, 4	;XCb`܂Ń[v
	goto	MAIN1

MAIN2
	call	WAIT_50M
	btfss	PORTB, 4	;XCb`͂Ȃ܂Ń[v
	goto	MAIN2

;*********@f[^M@**********

	movlw	"H"
	movwf	txdata		;f[^]pϐɂ
	call	RSTRANS		;RS232Co̓[`s

	movlw	"e"		; lɌJԂ
	movwf	txdata
	call	RSTRANS		

	movlw	"l"
	movwf	txdata
	call	RSTRANS		

	movlw	"l"
	movwf	txdata
	call	RSTRANS		

	movlw	"o"
	movwf	txdata
	call	RSTRANS		

	movlw	"!"
	movwf	txdata
	call	RSTRANS		

	movlw	0DH
	movwf	txdata
	call	RSTRANS		
	movlw	0AH		; 0D, 0AŁusv
	movwf	txdata
	call	RSTRANS		

	bcf	PORTB, 6	;LED_
	call	WAIT_500M	;0.5bԑ҂
	bsf	PORTB, 6	;LED
	goto	MAIN1		;Cɖ߂


;************************************************
;            RS232C M[`
;              txdata̒l𑗐M  
;************************************************

RSTRANS
		bcf	PORTB, 1	; X^[grbgMJnBM|[gRB1Low

		movlw	btime		; ]ԑ҂pJE^[
		movwf	sendt		; btime͂炩ߓ]xɂ킹Ē`ĂKv

TRANS10		decfsz	sendt, f
		goto	TRANS10		; ]x(ł9600bps)ɂ킹Ďԑ҂

		movlw	08H
		movwf	bitw		; M̒Pʂ8rbg1f[^Bbitw8rbgJEgpϐB
		nop

TRANS0		rrf	txdata, f	; txdataiMf[^j̍ŉʂ̃rbgCiL[rbgjɁA
		nop			; ̑̃rbg͂ꂼ1ʂ̂قiEjփVtg

		btfss	STATUS,C	; Crbg1瑗M|[gRB1highɁA0lowɂ
		bcf	PORTB, 1	; ʃrbg瑗M邱ƂɂȂ
		btfsc	STATUS,C
		bsf	PORTB, 1

		movlw	btime
		movwf	sendt
		
TRANS11		decfsz	sendt, f
		goto	TRANS11		; ]x(ł9600bps)ɂ킹Ďԑ҂

		decfsz	bitw, f		; rbgJE^1炷B
		goto	TRANS0		; ܂WrbgMĂȂ玟̃rbg𑗐M

		nop			; nopŎԒ
		nop
		nop
		nop
		nop
		nop
		bsf	PORTB, 1	; ŌɃXgbvrbg𑗐M
		movlw	btime
		movwf	sendt

TRANS12		decfsz	sendt, f	; stoprbgEFCg
		goto	TRANS12

		return

;*********************************
;  ^C}[Tu[`
;	WAIT_100U :100usec
;	WAIT_1M  :1msec
;	WAIT_50M  :50msec
;	WAIT_500M   :0.5sec
;*********************************

WAIT_100U				;100usec
		movlw	20H		
		movwf	counta		
W_LOOP1		decfsz	counta , f	;2+3*32-1=97
		goto	W_LOOP1
		nop
		return			;97+3=100(usec)

WAIT_1M					;1msec҂[v
		movlw	0AH
		movwf	countb
W_LOOP2		call	WAIT_100U	;2+(100+5)*10-1=1051
		decfsz	countb, f
		goto	W_LOOP2
		return			;1051+2=1053 (=1.053msec)

WAIT_50M				;50msec҂[v
		movlw	32H		;50񃋁[v
		movwf	countc
W_LOOP3		call	WAIT_1M
		decfsz	countc, f
		goto	W_LOOP3
		return

WAIT_500M				;0.5sec҂[v
		movlw	0AH		;10񃋁[v
		movwf	countd
W_LOOP4		call	WAIT_50M		
		decfsz	countd, f
		goto	W_LOOP4
		return	


		end



